<template>
    <fullscreen :fullscreen.sync="fullscreen" class="container">
        <div class="container-box">
            <toolList @iconCli='iconCli' :tooltit='tooltit'></toolList>
            <div class="search">
                <mySearch :searchList="searchList" @searchInfo="searchInfo"></mySearch>
                <el-button type="primary" @click="dialogCheck(3)" size="medium">添加</el-button>
            </div>
            <div class="tabbox">
                <el-table height="calc(100% - 40px)" class="com-table" ref="multipleTable" :data="tableData"
                    tooltip-effect="dark" size="small" border style="width: 100%" v-loading="loading">
                    <el-table-column prop="evaName" label="培训考核名称">
                    </el-table-column>
                    <el-table-column prop="evaTime" label="考核时间">
                    </el-table-column>
                    <el-table-column prop="trainNum" label="参训人数">
                    </el-table-column>
                    <el-table-column prop="evaNum" label="考试人数">
                    </el-table-column>
                    <el-table-column prop="opName" label="上传人">
                    </el-table-column>
                    <el-table-column prop="cityName" label="来源">
                    </el-table-column>
                    <el-table-column label="操作" width="220px" align="center">
                        <template slot-scope="scope">
                            <el-button size="mini" type="primary" @click="dialogCheck(1,scope.row)">查看</el-button>
                            <el-button size="mini" type="primary" @click="ksjg(scope.row)">考试结果</el-button>
                            <el-button size="mini" v-if="scope.row.opNo == userInfo.loginNo" type="danger" @click="delLine(scope.row)">删除</el-button>
                        </template>
                    </el-table-column>
                </el-table>
                <el-pagination class="pageBox" @current-change="currchange" layout="prev, pager, next" background
                    :total="total">
                </el-pagination>
            </div>
        </div>

        <el-dialog :title="titname" :visible.sync="dialogStatus" width="50%" :destroy-on-close="true"
            :modal-append-to-body="false" :close-on-click-modal="false" :before-close="closedia" :fullscreen="true">
            <div v-loading="loadinged">
                <el-form :model="infolist" ref="infolist" :rules="rules"
                    style="height: calc(100vh - 180px);overflow-y: scroll;">
                    <div class="info-line">
                        <el-form-item prop="evaName">
                            <span>考核名称</span>
                            <el-input v-model="infolist.evaName" placeholder="考核名称" :disabled="disableStatus">
                            </el-input>
                        </el-form-item>
                        <el-form-item prop="evaTime">
                            <span>考核时间</span>
                            <el-date-picker v-model="infolist.evaTime" type="date" placeholder="考核时间"
                                :disabled="disableStatus">
                            </el-date-picker>
                        </el-form-item>
                        <el-form-item prop="trainNum">
                            <span>参训人数</span>
                            <el-input v-model="infolist.trainNum" placeholder="参训人数"
                                :disabled="disableStatus">
                            </el-input>
                        </el-form-item>
                        <el-form-item prop="evaNum">
                            <span>考核人数</span>
                            <el-input v-model="infolist.evaNum" placeholder="考核人数"
                                :disabled="disableStatus">
                            </el-input>
                        </el-form-item>
                    </div>

                    <div v-if="disableStatus">
                        <uploadDown :datalist="datalist" :dialogStatus="uploadstatus"></uploadDown>
                    </div>
                    <div v-if="!disableStatus">
                        <myUpload @uploadBack="uploadBack" :fileInfo="fileInfo" :fileList="fileInfo.fileList">
                        </myUpload>
                    </div>

                </el-form>
                <div slot="footer" style="float: right;margin-top: 20px;">
                    <el-button type="primary" @click="dialogCliadd(2)">确 定</el-button>
                    <el-button @click="dialogCliadd(1)">取 消</el-button>
                </div>
            </div>
        </el-dialog>
        <myMessage :messTit='messTit' @closeMessage="closeMessage" :centerDialogVisible="centerDialogVisible"
            v-if="centerDialogVisible"></myMessage>
    </fullscreen>

</template>
<script>
    import mySearch from "../../../components/search.vue";
    import myMessage from "../../../components/myMessage.vue"
    import toolList from '../../../components/toolList'
    import myUpload from '../../../components/upload'
    import uploadDown from '../../../components/uploadDown.vue'
    import deptTreeOnly from "../../../components/deptTreeOnly.vue"

    export default {
        components: {
            mySearch,
            myMessage,
            toolList,
            myUpload,
            uploadDown,
            deptTreeOnly
        },
        data() {
            const evaName = (rule, value, callback) => {
                if (!this.infolist.evaName) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
            const evaTime = (rule, value, callback) => {
                if (!this.infolist.evaTime) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
            const trainNum = (rule, value, callback) => {
                if (!this.infolist.trainNum) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
            const evaNum = (rule, value, callback) => {
                if (!this.infolist.evaNum) {
                    callback(new Error('不能为空'))
                } else {
                    callback()
                }
            }
            return {
                rules: {
                    evaName: [{
                        required: true,
                        trigger: 'blur',
                        validator: evaName
                    }],
                    evaTime: [{
                        required: true,
                        trigger: 'change',
                        validator: evaTime
                    }],
                    trainNum: [{
                        required: true,
                        trigger: 'blur',
                        validator: trainNum
                    }],
                    evaNum: [{
                        required: true,
                        trigger: 'blur',
                        validator: evaNum
                    }],
                },
                searchList: [{
                        type: 'input',
                        tit: '考核名称',
                        value: '',
                        width: '49%'
                    },
                    {
                        type: 'date',
                        tit: '考核时间',
                        value: '',
                        width: '49%',
                    },
                ],
                tooltit: '培训考核',
                fullscreen: false,
                total: 0,
                pageSize: 1,
                tableData: [{}],
                dialogStatus: false,
                disableStatus: false,
                titname: '',
                infolist: {
                    evaTime:'',
                },
                userInfo: {},
                params: {},
                centerDialogVisible: false,
                messTit: '',
                delid: '',
                loading: false,
                loadinged: false,
                docType:[],
                contentType:[],
                infodata:[{}],
                infodatat:[{}],
                datalist: {
                    url: '/market/compatt/downfile',
                    type: 1
                },
                uploadstatus: false,
                attList: [],
                fileInfo: {
                    limit: 5,
                    url: '/market/cmkAttachInfo/upload',
                    fileList: [],
                    uploadType:'newlyCoop'
                },
            }
        },
        methods: {
            ksjg(v){
                let s = 1;
                if(v.opNo == this.userInfo.loginNo){
                    s=2
                }
                let id = v.id + ',' + s;
                this.$router.push({
                    path: "/trainReason?id=" + id,
                    query: {
                        id: id,
                    }
                });
                this.setabList("考核结果", "/trainReason?id=" + id);

            },
            setabList(n, p) {
                let params = {
                    children: "",
                    name: n,
                    rountPath: p,
                    target: "_self",
                };
                for (let i = 0; i < this.$store.state.tabList.length; i++) {
                    if (this.$store.state.tabList[i].name === params.name) {
                        this.$store.state.tabList[i] = params;
                    }
                }
                let set = new Set([...this.$store.state.tabList, params]);
                set.add(params);
                this.$store.commit("setDefaultActive", params.rountPath);
                this.$store.commit("setTabList", Array.from(set));
            },
            uploadBack(v) {
                this.attList = v;
            },
            //搜索数据
            searchInfo(v) {
                this.params = {};
                v[0] ? this.params.evaName = v[0] : '';
                v[1] ? this.params.evaTime = this.$formatDate(v[1], "YYYY-MM-DD") : '';
                this.getList(this.params, this.pageSize);
            },
            choline(v, n) {
            	if (v == 1) {
            		this.infodata.push({})
            	} else {
            		this.infodata.splice(n.$index, 1)
            	}
            },
            cholinet(v, n) {
            	if (v == 1) {
            		this.infodatat.push({})
            	} else {
            		this.infodatat.splice(n.$index, 1)
            	}
            },
            closedia() {
                this.infolist = {
                    evaTime:'',
                };
                this.infodata = [{}];
                this.infodatat = [{}];
                this.attList = [];
                this.fileInfo.fileList = [];
                this.dialogStatus = false;
            },
            //获取列表
            getList(v, n) {
                this.pageSize = n;
                let _this = this;
                this.loading = true;
                this.$http({
                    url: "/market/cStoreScheTrainEva/queryPage",
                    method: "post",
                    headers: {
                        "Content-Type": "application/json",
                        "page": '{"pageNo":"' + n + '","pageSize":"10"}'
                    },
                    data: v,
                }).then((res) => {
                    this.tableData = res.data.data;
                    this.total = res.data.totalRecord;
                    this.loading = false;
                });
            },
            // 分页
            currchange(v) {
                this.pageSize = v;
                this.getList(this.params, this.pageSize);
            },
            //申请
            dialogCheck(v, n) {
                this.dialogStatus = true;
                let infolist = Object.assign({}, n);
                if (v === 1) {
                    this.titname = '查看';
                    this.disableStatus = true;
                } else if (v === 2) {
                    this.titname = '修改';
                    this.disableStatus = false;
                } else if (v === 3) {
                    this.titname = '添加';
                    this.disableStatus = false;
                    return
                }
                this.infolist = infolist;
                this.$http({
                    url: "/market/cStoreScheTrainEva/query",
                    method: "post",
                    headers: {
                        "Content-Type": "application/json",
                    },
                    data: {
                        id: n.id
                    },
                }).then((res) => {
                    this.infodatat = res.data.docList;
                    this.infodata = res.data.proList;
                    res.data.attList.forEach(item => {
                        this.fileInfo.fileList.push({
                            name: item.fileName,
                            url: '',
                            id: item.id,
                            fileCode: item.fileCode,
                            fileName: item.fileName
                        });
                        this.attList.push({
                            name: item.fileName,
                            url: '',
                            id: item.id,
                            fileCode: item.fileCode,
                            fileName: item.fileName
                        });
                    })
                    this.datalist.attList = [];
                    this.datalist.attList = res.data.attList;
                    this.infolist.attList = [];
                    this.infolist.attList = res.data.attList;
                    this.uploadstatus = !this.uploadstatus;
                });
            },
            //添加
            dialogCliadd(v) {
                if (v == 1 || this.titname == '查看') {
                    this.infolist = {
                        evaTime:'',
                    };
                    this.infodata = [{}];
                    this.infodatat = [{}];
                    this.attList = [];
                    this.fileInfo.fileList = [];
                    this.dialogStatus = false;
                    return
                }
                let _this = this;
                let info = this.infolist;
                info.opTime = _this.$formatDate(new Date(), "YYYY-MM-DD");
                info.opNo = this.userInfo.loginNo;
                info.opName = this.userInfo.loginName;
                info.evaTime = info.evaTime ? _this.$formatDate(info.evaTime, "YYYY-MM-DD") : '';

                let attList = [];
                for (let i = 0; i < this.attList.length; i++) {
                    attList.push({
                        id: this.attList[i].id,
                        fileCode: this.attList[i].fileCode,
                        fileName: this.attList[i].fileName,
                    });
                }
                info.attList = attList;

                if (this.titname == '修改') {
                    this.submitInfo("/market/cStoreScheTrainEvaDetail/update", info);
                } else {
                    this.submitInfo("/market/cStoreScheTrainEva/add", info);
                }
            },

            submitInfo(u, v) {
                let _this = this;
                this.$refs.infolist.validate(valid => {
                    if (valid) {
                        this.$http({
                            url: u,
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                            },
                            data: v,
                        }).then((res) => {
                            if (res.data.result === 1) {
                                _this.$message({
                                    message: res.data.desc,
                                    type: 'error'
                                });
                            } else {
                                _this.$message({
                                    message: '成功',
                                    type: 'success'
                                });
                                _this.closedia();
                                _this.infolist = {
                                    evaTime:'',
                                };
                                _this.infodata = [{}];
                                _this.infodatat = [{}];
                                _this.getList(this.params, this.pageSize);
                            }

                        });
                    }
                })
            },
            closeMessage(v) {
                this.centerDialogVisible = false;
                let _this = this;
                if (v === 1) {
                    _this.$http({
                        url: "/market/cStoreScheTrainEva/del",
                        method: "post",
                        headers: {
                            "Content-Type": "application/json",
                        },
                        data: {
                            id: this.delid
                        },
                    }).then((res) => {
                        if (res.data.result === 1) {
                            _this.$message({
                                message: res.data.desc,
                                type: 'error'
                            });
                        } else {
                            _this.$message({
                                message: '删除成功',
                                type: 'success'
                            });
                            _this.getList(this.params, this.pageSize);
                        }
                    });
                }
            },
            //删除
            delLine(v) {
                this.centerDialogVisible = true;
                this.messTit = '即将删除此条数据, 是否删除?';
                this.delid = v.id;
            },
            //功能栏
            iconCli(v) {
                if (v === 1) {
                    this.getList(this.params, this.pageSize);
                }
                if (v === 2) {
                    this.fullscreen = !this.fullscreen
                }
            },
            getUser() {
                this.userInfo = JSON.parse(window.sessionStorage.userInfo);
            },
        },
        mounted() {
            this.getList({}, 1);
            this.getUser();
        },
        created() {

        }
    }
</script>
<style scoped lang="scss">
    .onetab {
        margin-bottom: 20px;
        padding: 0 20px;
    }

    .titbox {
        div {
            float: right;

            i {
                font-size: 22px;
                margin-left: 20px;
                cursor: pointer;
            }
        }
    }

    .tabbox {
        margin-top: 15px;
    }

    .pageBox {
        text-align: right;
        margin-top: 10px;
    }

    .info-line {
        width: 100%;
        display: block;
        padding-left: 20px;

        div {
            width: 50%;
            display: inline-block;
        }

        span {
            width: 100px;
            display: inline-block;
            text-align: left;

            i {
                color: red;
                display: inline-block;
                padding-right: 5px;
            }
        }

        .el-select,
        .el-input {
            width: calc(100% - 120px);
        }
    }

    .online {
        width: 100%;

        .el-select {
            width: calc(100% - 100px);
        }

        span {
            vertical-align: top;
        }

        .el-textarea {
            width: calc(100% - 120px);
        }

        .tree {
            width: calc(50% - 60px);
            display: inline-block;
            margin-right: 20px;
            height: 300px;
            overflow-y: scroll;

            .el-icon-error {
                float: right;
                font-size: 20px;
                margin-top: 9px;
                cursor: pointer;
            }
        }

        .treeUser {
            margin: 0;
            border: 1px solid #ddd;

            p {
                background: #f4f4f4;
                padding: 0 20px;
                margin-bottom: 5px;
            }
        }

        .treeUserb {
            width: calc(100% - 100px);
            border: 1px solid #ddd;
            background: #f4f4f4;
            border-radius: 3px;
            height: auto;
            overflow: hidden;

            p {
                display: inline-block;
                padding: 0 20px;
                margin-bottom: 5px;
            }
        }
    }

    .adv-type {
        margin-top: 20px;
        display: flex;
        justify-content: space-between;
        flex-wrap: wrap;
        // border: 1px solid #ddd;
        border-radius: 5px;
        padding: 20px;
        box-shadow: 0 2px 12px 0 rgba(0, 0, 0, .1);

        div {
            width: 33%;
            text-align: center;
            height: 80px;
            overflow: hidden;
            min-width: 100px;
            cursor: pointer;
            padding-top: 10px;
            margin: 10px 0;
        }

        div:hover {
            background: #CFE8FC;
            border-radius: 5px;
        }

        span {
            width: 100%;
            display: inline-block;
            height: 40px;

            // line-height: 40px;
            i {
                color: #0074D9;
                font-size: 36px;
            }
        }
    }
</style>
